''Todo:
'-obstacles


'#Include "fbmld.bas"

#Include "GL/gl.bi"
#Include "SDL/SDL.bi"

#Define ONEUNIT 16
#Define BORDER 2
#Define WCELLS 20
#Define HCELLS 20
#Define room_width ONEUNIT*WCELLS
#Define room_height ONEUNIT*HCELLS
#Define room_speed 30

Randomize Timer
Type snake_controller_fwd As snake_controller
Type item_controller_fwd As item_controller
Type item_fwd As item

#Include "typeObstacle.bas"
#Include "typeItem.bas"
#Include "typeItemController.bas" 
#Include "typeSnake.bas"
#Include "typeSnakeController.bas"

#Include "typeObstacleMethods.bas"
#Include "typeItemMethods.bas"
#Include "typeItemControllerMethods.bas"
#Include "typeSnakeMethods.bas"
#Include "typeSnakeControllerMethods.bas"


Private Function SDL_GL_Init(ByVal _video As SDL_Surface Ptr) As Integer
	If (SDL_Init(SDL_INIT_EVERYTHING)<>0)Then
		Return -1
	EndIf
	
	SDL_WM_SetCaption("FBSnake","")
	SDL_GL_SetAttribute(16,1)
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1)
	SDL_GL_SetAttribute(SDL_GL_RED_SIZE,5)
	SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE,5)
	SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE,5)
	SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE,16)
	
	_video=SDL_SetVideoMode(room_width,room_height,16,SDL_OPENGL)
	
	If (_video=0)Then
		Return -1
	EndIf
	
	glViewport(0,0,room_width,room_height)
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity()
	
	glOrtho(0,room_width,room_height,0,-1,1)
	
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
	glEnable(GL_DEPTH_TEST)
	glDepthFunc(GL_LEQUAL)
	
	glShadeModel(GL_SMOOTH)
	glClearColor(1.0f,0.6f,0.8f,1.0f)
	glClearDepth(1.0f)
	
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST)
	Return 0
End Function

Dim shared As Integer quit =0

Private Sub main ()
	
	Dim As SDL_Surface Ptr _video=0
	Dim As SDL_Event _event

	quit=SDL_GL_Init(_video)
	If (quit)Then
		Print "SDL INIT FAILED!"
		Exit Sub
	EndIf
	
	Dim As Double t=Timer,t2=timer
'	Dim As Integer fps=0', ## moved=0 ##
	
	Dim As obstacle obstacle_list(WCELLS*HCELLS)
	Dim As Integer obstacle_count
	
	Dim As item_controller items
	Dim As snake_controller players
	
	items.define_pc(@players)
	players.define_ic(@items)
	players.define_obstacles(@obstacle_count,@obstacle_list(0))
	players.allDead=0
	
	'Set up the play conditions:
	players.length0=3
	players.speed0=0.3f
	players.snake_snake_collision=0
	players.dead_snake_collision=0
	
	'Add the players:
	players.addPlayer("Player ONE",255,128,128,5,5,SNAKE_RIGHT)
	players.player(0).mapKey(SNAKE_UP,SDLK_UP)
	players.player(0).mapKey(SNAKE_DOWN,SDLK_DOWN)
	players.player(0).mapKey(SNAKE_RIGHT,SDLK_RIGHT)
	players.player(0).mapKey(SNAKE_LEFT,SDLK_LEFT)
	
	players.addPlayer("Player TWO",128,128,255,WCELLS-6,HCELLS-6,SNAKE_LEFT)
	

	players.player(1).mapKey(SNAKE_UP,SDLK_w)
	players.player(1).mapKey(SNAKE_DOWN,SDLK_s)
	players.player(1).mapKey(SNAKE_RIGHT,SDLK_d)
	players.player(1).mapKey(SNAKE_LEFT,SDLK_a)
	
	'define some obstacles:
	obstacle_count=3
	obstacle_list(0).x=10
	obstacle_list(0).y=10
	
	obstacle_list(1).x=11
	obstacle_list(1).y=10
	
	obstacle_list(2).x=12
	obstacle_list(2).y=10


	Cls
	Print "Game Log:"
	
	While (Not quit)and(Not players.allDead)
		glClear(GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT)
		While SDL_PollEvent(@_event)<>0
			Select Case _event.type
				Case SDL_Exit
					quit=-1
					Exit Sub
				Case SDL_KEYDOWN
					Select Case _event.key.keysym.sym
						Case SDLK_ESCAPE
							quit=-1
							Exit Sub
					End Select
			End Select
			players.handleEvents(_event)
		Wend
		
		players.doStep()
		items.doStep()
		For i As Integer=0 To obstacle_count-1
			obstacle_list(i).draw()
		Next i
		
		players.drawScores()
		
		SDL_GL_SwapBuffers()
		
		While (Timer-t2<=1/room_speed)
			SDL_Delay(1)
		Wend
		t2=timer
'		fps+=1
'		If (Timer-t>=1)Then
'			SDL_WM_SetCaption("FPS: " & fps,"")
'			fps=0
'			t=timer
'		EndIf

	Wend
End Sub


While Not quit
	main()
	If (Not quit) Then SDL_Delay(1000)
	SDL_Quit()
Wend