#Macro _SNAKEKEYDIR_(_dir,_opp)
	If (This.direction_queue_count>0)Then
		If (This.direction_queue(This.direction_queue_count-1)<>_opp)Then
			If (This.moved)Then
				This.direction_queue_count=0
			Else
				This.direction_queue(This.direction_queue_count)=_dir
				This.direction_queue_count+=1
			Endif	
			This.moved=0
		EndIf
	Else
		If (This.direction<>_opp)Then
			This.direction_queue(0)=_dir
			This.direction_queue_count=1
		EndIf
	EndIf
#EndMacro

Private Sub snake.setup()
	dead=0
	score=0
	speed_count=0.0f
	
	moved=0
	
	food_count=0
	direction_queue_count=0
	
	'line up the body after the head:
	For i As Integer=1 To This.length-1
		This.body(i,0)=This.body(i-1,0)-Cos(This.direction*90*3.142/180)
		This.body(i,1)=This.body(i-1,1)+Sin(This.direction*90*3.142/180)
	Next i
End Sub

Private Sub snake.mapKey (ByRef _key As Integer, ByRef _keycode As Integer)
	Select Case As Const _key
		Case SNAKE_UP
			This.keyup=_keycode
		Case SNAKE_DOWN
			This.keydown=_keycode
		Case SNAKE_LEFT
			This.keyleft=_keycode
		Case SNAKE_RIGHT
			This.keyright=_keycode
	End Select
End Sub

Private Sub snake.handleEvents (ByRef _event As SDL_Event)
	Select Case _event.type
		Case SDL_KEYDOWN
			Select Case _event.key.keysym.sym
				Case This.keyup
					_SNAKEKEYDIR_(SNAKE_UP,SNAKE_DOWN)
				Case This.keydown
					_SNAKEKEYDIR_(SNAKE_DOWN,SNAKE_UP)
				Case This.keyleft
					_SNAKEKEYDIR_(SNAKE_LEFT,SNAKE_RIGHT)
				Case This.keyright
					_SNAKEKEYDIR_(SNAKE_RIGHT,SNAKE_LEFT)
			End Select
	End Select
End Sub

Private Sub snake.doStep()
	If (Not This.dead)Then This.move()
	This.draw()
End Sub

Private Function snake.direction_queue_pop() As Integer
	Dim As Integer temp
	temp=This.direction_queue(0)
	If (This.direction_queue_count>0)Then
		This.direction_queue_count-=1
	EndIf
	For i As Integer =0 To This.direction_queue_count-1
		This.direction_queue(i)=This.direction_queue(i+1)
	Next i
	Return temp
End Function

Private Sub snake.move()
	This.speed_count+=This.speed
	While (This.speed_count>=1)
		This.speed_count-=1
		moved=0
		
		For i As Integer=This.length-1 To 1 Step -1
			This.body(i,0)=This.body(i-1,0)
			This.body(i,1)=This.body(i-1,1)
		Next i
		
		If (This.direction_queue_count>0)Then
			This.direction=This.direction_queue_pop()
		EndIf
		
		Select Case As Const This.direction
			Case SNAKE_RIGHT
				Select Case This.body(0,0)+1
					Case 0 To WCELLS-1
						 This.body(0,0)+=1
					Case Is>=WCELLS
						This.body(0,0)=0
				End Select
				
			Case SNAKE_UP
				Select Case This.body(0,1)-1
					Case 0 To HCELLS-1
						 This.body(0,1)-=1
					Case Is<0
						This.body(0,1)=HCELLS-1
				End Select
				
			Case SNAKE_LEFT
				Select Case This.body(0,0)-1
					Case 0 To WCELLS-1
						 This.body(0,0)-=1
					Case Is<0
						This.body(0,0)=WCELLS-1
				End Select
				
			Case SNAKE_DOWN
				Select Case This.body(0,1)+1
					Case 0 To HCELLS-1
						 This.body(0,1)+=1
					Case Is>=HCELLS
						This.body(0,1)=0
				End Select
		End Select
		
		This.triggerMove()
		(*This.parent).triggerMove(This)
	Wend
	If (This.speed_count<0)Then This.speed_count=0
End Sub

Private Sub snake.checkCollision()
	'Eat and digest food:
	This.eat()
	This.digest()
	
	'Collision with own body:
	For i As Integer=1 To This.length-1
		If (This.body(0,0)=This.body(i,0))and(This.body(0,1)=This.body(i,1))Then
			(*This.parent).death_enqueue(This.pnum)
			Exit Sub
		EndIf
	Next i
	
	If ((*This.parent).snake_snake_collision)or((*This.parent).dead_snake_collision)Then
		'collision with other snakes:
		For i As Integer=0 To (*This.parent).player_count-1
			If (@(*This.parent).player(i)=@This)Then Continue For
			If ((*This.parent).player(i).dead) then
				If (Not (*This.parent).dead_snake_collision)Then
					Continue For
				EndIf
			Else
				If (Not (*This.parent).snake_snake_collision)Then
					Continue For
				EndIf
			EndIf
			For j As Integer=0 To (*This.parent).player(i).length-1
				If (This.body(0,0)=(*This.parent).player(i).body(j,0))and(This.body(0,1)=(*This.parent).player(i).body(j,1))Then
					(*This.parent).death_enqueue(This.pnum)
					Exit Sub
				EndIf
			Next
		Next i
	EndIf
	
	'Collision with walls:
	For i As Integer=0 To (*This.obstacle_count)-1
		If (This.body(0,0)=This.obstacle_list[i].x)and(This.body(0,1)=This.obstacle_list[i].y)Then
			(*This.parent).death_enqueue(This.pnum)
			Exit Sub
		EndIf
	Next i
End Sub

Private Sub snake.eat()
	For i As Integer =0 To (*This._ic).item_queue_count-1
		If (This.body(0,0)=(*(*This._ic).getItem(i)).x)and(This.body(0,1)=(*(*This._ic).getItem(i)).y)Then
			This.food_queue(This.food_count,0)=This.body(0,0)
			This.food_queue(This.food_count,1)=This.body(0,1)
			This.food_queue(This.food_count,2)=(*(*This._ic).getItem(i)).score_increment
			This.food_queue(This.food_count,3)=(*(*This._ic).getItem(i)).length_increment
			This.food_count+=1
			This.speed+=(*(*This._ic).getItem(i)).speed_increment
			
			If (This.speed<(*This.parent).speed0)Then This.speed=(*This.parent).speed0
			If (This.length<(*This.parent).length0)Then This.length=(*This.parent).length0
			
			(*This._ic).item_removal_enqueue((*This._ic).item_queue(i))
			This.triggerEat((*(*This._ic).getItem(i)))
			(*This.parent).triggerEat(This,(*(*This._ic).getItem(i)))
		EndIf
	Next i
	
End Sub

Private Sub snake.digest()
	For i As Integer=0 To This.food_count-1
		If (This.food_queue(i,0)=This.body(This.length-1,0))and(This.food_queue(i,1)=This.body(This.length-1,1))Then
			This.body(This.length,0)=This.food_queue(i,0)
			This.body(This.length,1)=This.food_queue(i,1)
			This.score+=This.food_queue(i,2)
			This.length+=This.food_queue(i,3)
			This.food_count-=1
			For j As Integer=i To This.food_count-1
				This.food_queue(j,0)=This.food_queue(j+1,0)
				This.food_queue(j,1)=This.food_queue(j+1,1)
				This.food_queue(j,2)=This.food_queue(j+1,2)
				This.food_queue(j,3)=This.food_queue(j+1,3)
			Next j
			This.triggerDigest()
			(*This.parent).triggerDigest(This)
		EndIf
	Next i
End Sub

Private Sub snake.triggerMove()
	'do stuff when moved
End Sub

Private Sub snake.triggerDie()
	'do stuff when die
End Sub

Private Sub snake.triggerEat(ByRef _item As item)
	'do stuff when eat
End Sub

Private Sub snake.triggerDigest()
	'do stuff when digest
End Sub

Private Sub snake.draw()
	'Background:
	glColor3ub(0,0,0)
	For i As Integer=This.length-1 To 0 Step -1
		glBegin(GL_QUADS)
			glVertex3f(This.body(i,0)*ONEUNIT-BORDER,							This.body(i,1)*ONEUNIT-BORDER, 			-0.9f)
			glVertex3f(This.body(i,0)*ONEUNIT+ONEUNIT+BORDER,				This.body(i,1)*ONEUNIT-BORDER, 			-0.9f)
			glVertex3f(This.body(i,0)*ONEUNIT+ONEUNIT+BORDER,				This.body(i,1)*ONEUNIT+ONEUNIT+BORDER, -0.9f)
			glVertex3f(This.body(i,0)*ONEUNIT-BORDER,							This.body(i,1)*ONEUNIT+ONEUNIT+BORDER, -0.9f)
		glEnd()
	Next i

	'foreground:
	glColor3ub(This.color(0),This.color(1),This.color(2))
	For i As Integer=This.length-1 To 0 Step -1
		glBegin(GL_QUADS)
			glVertex3f(This.body(i,0)*ONEUNIT,									This.body(i,1)*ONEUNIT, 					iif(This.dead,-0.85f,0.5f))
			glVertex3f(This.body(i,0)*ONEUNIT+ONEUNIT,						This.body(i,1)*ONEUNIT, 					iif(This.dead,-0.85f,0.5f))
			glVertex3f(This.body(i,0)*ONEUNIT+ONEUNIT,						This.body(i,1)*ONEUNIT+ONEUNIT, 			iif(This.dead,-0.85f,0.5f))
			glVertex3f(This.body(i,0)*ONEUNIT,									This.body(i,1)*ONEUNIT+ONEUNIT, 			iif(This.dead,-0.85f,0.5f))
		glEnd()
	Next i
	
	glColor3ub(128,128,128)
	For i As Integer=This.food_count-1 To 0 Step -1
		glBegin(GL_QUADS)
			glVertex3f(This.food_queue(i,0)*ONEUNIT,							This.food_queue(i,1)*ONEUNIT, 			iif(This.dead,-0.8f,0.6f))
			glVertex3f(This.food_queue(i,0)*ONEUNIT+ONEUNIT,				This.food_queue(i,1)*ONEUNIT, 			iif(This.dead,-0.8f,0.6f))
			glVertex3f(This.food_queue(i,0)*ONEUNIT+ONEUNIT,				This.food_queue(i,1)*ONEUNIT+ONEUNIT, 	iif(This.dead,-0.8f,0.6f))
			glVertex3f(This.food_queue(i,0)*ONEUNIT,							This.food_queue(i,1)*ONEUNIT+ONEUNIT, 	iif(This.dead,-0.8f,0.6f))
		glEnd()
	Next i
	
	If (This.dead)Then
		glColor3ub(255,0,0)
		glBegin(GL_QUADS)
			glVertex3f(This.body(0,0)*ONEUNIT,									This.body(0,1)*ONEUNIT, 					-0.7f)
			glVertex3f(This.body(0,0)*ONEUNIT+ONEUNIT,						This.body(0,1)*ONEUNIT, 					-0.7f)
			glVertex3f(This.body(0,0)*ONEUNIT+ONEUNIT,						This.body(0,1)*ONEUNIT+ONEUNIT, 			-0.7f)
			glVertex3f(This.body(0,0)*ONEUNIT,									This.body(0,1)*ONEUNIT+ONEUNIT, 			-0.7f)
		glEnd()
	EndIf
End Sub
